<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for snoot.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
snoot - translate pre-processed C to SUIF

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>snoot</B> [ <I>options</I> ] <I>infile</I> <I>outfile</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>snoot</I> program is the core of the SUIF C front end. It
translates from pre-processed ANSI-C to SUIF. The SUIF
code that <I>snoot</I> produces is non-standard, however; it must
be passed through <I>porky</I> with the <I>-defaults</I> flag before it
becomes standard SUIF that other passes can handle.
<P>
The entire C front-end for SUIF consists of three passes.
First, <I>cpp,</I> the ANSI-C pre-processor. This is not
included with SUIF. Any standard ANSI-C pre-processor may
be used; the gnu C pre-processor that is included with gcc
is one option. The output of <I>cpp</I> is then fed into <I>snoot.</I>
The output from <I>snoot</I> is the first SUIF file. Then the
last stage is <I>porky</I> with the <I>-defaults</I> option. Together,
these three passes turn ANSI-C into standard SUIF.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>


<DL>

<DT><B>-W</B> </DT></DT>
<DD>    Turn on more warning messages. By default, only
important warnings are displayed. If used a second
time, all possible warnings are issued.
</DD>

<DT><B>-w</B> </DT></DT>
<DD>    Suppress all warning messages. This overrides the
<B>-W</B> option.
</DD>

<DT><B>-keep-comments</B></DT></DT>
<DD>
Save all comments from the C code as C comment"
annotations on SUIF ``mrk'' instructions.    By
default, comments are ignored.
</DD>
</DL>
<P>
Note that for this to have any effect, the C comments
must have been preserved by the C pre-processor;
by default <I>cpp</I> throws them away before <I>snoot</I>
even sees the code. Use the <B>-C</B> option for <I>cpp</I> to
save comments in the pre-processing stage.

<DL>

<DT><B>-ignore-comments</B></DT></DT>
<DD>
Do not save C comments. This is the default. If
both <B>-keep-comments</B> and <B>-ignore-comments</B> are specified,
the one that occurs latest on the command
line takes effect.
</DD>

<DT><B>-x</B> </DT></DT>
<DD>    Write cross-reference of symbol uses as source
references annotations on the SUIF symbols. The
location of each reference in the source file is
recorded.
</DD>

<DT><B>-P</B> </DT></DT>
<DD>    Print function prototypes and global variable declarations
to standard error. This output can be
appended to the top of a source file so that the
next time it's compiled more type checking can be
done.
</DD>

<DT><B>-s</B><I>density</I></DT></DT>
<DD>
Set the density of labels used as a cutoff for
using SUIF mbr instructions instead of individual
comparisons for switch statements. The <I>density</I> is
interpreted as a floating point value. The default
is 0.5, meaning that at least half the values in a
range have to have case labels before an mbr
instruction is used.
</DD>

<DT><B>-e</B><I>n</I> </DT></DT>
<DD>   Set the maximum number of error messages <I>snoot</I> will
issue before giving up. The default is 20. Ordinarily,
<I>snoot</I> will issue an error message and continue
to look for more errors. Even if the rest of
the program can successfully be translated, <I>snoot</I>
will still return an error code. Once the limit is
reached, <I>snoot</I> assumes that it is so hopelessly
confused by earlier errors that there's no point in
reporting any more.
</DD>

<DT><B>-mark-execution-points</B></DT></DT>
<DD>
Put sequence point annotations in the SUIF code
corresponding to sequence points in the source
code, when possible. Temporary values will be
spilled into new variables if necessary. The one
situation where sequence points are not properly
inserted is for C ``for()'' statements that are
translated into SUIF TREE_FOR nodes. There is no
place on a SUIF TREE_FOR to put the sequence point
that comes between evaluation of the incrementing
expression and the test expression.
</DD>
</DL>
<P>
Sequence points are defined in the ANSI C standard
as points in the execution where some things are
guaranteed to have already been executed and others
not yet executed. The standard defines exactly
where they occur. The option of marking these in
the SUIF code is provided in case later passes want
to use them to print traces of variable values or
something of that sort.

<DL>

<DT><B>-ignore-execution-points</B></DT></DT>
<DD>
Do not mark sequence points in the SUIF code. This
is the default. If both <B>-mark-execution-points</B> and
<B>-ignore-execution-points</B> are specified, the one
that occurs latest on the command line takes
effect.
</DD>

<DT><B>-null-check</B></DT></DT>
<DD>
Insert code to check at runtime for a NULL pointer
every time memory is explicitly read or written in
the C code (i.e. for every use of the ``[]'',
``-&gt;'', or unary ``*'' operators). If a NULL
pointer is found, an error message is issued giving
the source line number and file and the program
aborts.
</DD>

<DT><B>-no-null-check</B></DT></DT>
<DD>
Do not insert code to check at runtime for NULL
pointers. This is the default. If both <B>-nullcheck</B>
and <B>-no-null-check</B> are specified, the one
that occurs latest on the command line takes
effect.
</DD>

<DT><B>-T</B><I>target-name</I></DT></DT>
<DD>
Use the system-specific target parameters specified
by <I>target-name</I> in compilation. This is used in
cross-compilation or to generate code for a different
back-end C compiler. The parameters include
such things as the byte order of the machine, the
sizes of the various types, and whether the type
``char'' is signed or unsigned. The default is to
use the parameters from the C compiler used to
build snoot (typically gcc).
</DD>
</DL>
<P>
To see a list of targets <I>snoot</I> understands, type
<I>snoot</I> <I>-T-.</I> Target information is stored in the
<I>snoot</I> source file <I>config.h.</I> See the <I>snoot</I> source
file <I>find</I><B>_</B><I>params.c</I> for information on generating
target information for new systems.

<DL>

<DT><B>-keep-typedef-info</B></DT></DT>
<DD>
Create dummy variables to represent typedef names.
The dummy variables are given type ``int'' and have
typedef name annotations attached. The data on
the annotation contains an immed list with one
item, the type of the typedef.
</DD>

<DT><B>-builtin</B> <I>builtin-name</I></DT></DT>
<DD>
Consider <I>builtin-name</I> to be a built-in identifier.
That means that <I>builtin-name</I> can be used as a variable
or followed by arguments in parentheses and
each such expression will be translated to a SUIF
generic instruction with <I>builtin-name</I> as its name.
Within the parentheses can be a comma-separated
argument list, where each argument can be a type, a
string literal, or an expression. These generic
instructions will be passed through most SUIF
passes and <I>s2c</I> will translate them back into a form
similar to their form in the original source code.
This can be used to implement asm() directives, or
built-in identifiers used for vararg macros in
headers for some systems. Note that an alternative
to specifying built-in identifiers on the commandline
with this switch is to specify them in the
configuration file config.h".
</DD>

<DT><B>-force-enum-is-int</B></DT></DT>
<DD>
Force all enum types to use type ``int'' as their
equivalent type. Ordinarily, enum types are mapped
to the smallest integer type that can contain all
their enumeration constants. This option overrides
that for compatibility, since some programs assume
that the compiler maps enums only to ``int'' under
all circumstances.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>History</B></A></H2>

<P>
The first ANSI-C front-end for SUIF was <I>snout,</I> written by
Robert French. It was based on <I>lcc,</I> a portable C frontend
with a code-generation interface (see ``A Code Generation
Interface for ANSI C'' by Fraser and Hanson). Since
the back-end interface provided by <I>lcc</I> is too low-level
for SUIF, some substantial changes were made in various
levels of <I>lcc</I> code and data-structures to preserve more
information when generating SUIF code.
<P>
When the SUIF system was overhauled, Todd Smith rewrote
the SUIF-specific parts of <I>snout</I> to create <I>snoot</I> for new
SUIF. When more changes were made to SUIF that required
more information to be preserved that lcc was losing
early-on, Chris Wilson rewrote <I>snoot.</I> Various internal
transformations and datastructures used by lcc were
removed. Now the front-end of lcc is used to generate
SUIF code directly.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">History</A></LI>
</UL>
</BODY></HTML>
